<template>
  <header
    class="appHeader _fixed"
    v-scroll-lock="scrollable"
    :class="{'-open-menu': hasOpenMenu}">
    <div
      class="appHeader-wrapper">
      <div class="appHeader-top container">
        <AppButton
          :classes="burgerMenu"
          :class="{'-open': hasOpenMenu}"
          @click.native="openMenuFixBody">
          <span
            slot="button-item"
            class="button-item">
            <img
              svg-inline
              src="assets/svg/redesign/burger.svg">
            <img
              svg-inline
              src="assets/svg/redesign/cross-bold.svg">
          </span>
        </AppButton>
        <flink
          href="/"
          domain="main"
          class="link">
          <span class="logo">
            <span class="logo-img">
              <img
                svg-inline
                src="~/assets/svg/redesign/logo-main.svg">
            </span>
            <span class="logo-caption">Найдётся всё для вашего авто</span>
          </span>
        </flink>
        <AppSearch
          :class="{ '-open': hasOpenMenuSearch} "
          :has-suggestions="true"/>
        <AppButton
          :classes="buttonSearch"
          :class="{ '-open': hasOpenMenuSearch }"
          @click.native="openSearch">
          <span
            class="button-item"
            slot="button-item">
            <img
              svg-inline
              src="~/assets/svg/redesign/magnifer-bold.svg">
          </span>
        </AppButton>
        <!-- <div
          v-if="hasOpenMenuFilters"
          class="appHeader-filters __box-gray">
          <ContractFilters
            @hide="openFilters()"/>
        </div>
        <AppButton
          :classes="buttonFilter"
          :class="{ '-open': hasOpenMenuFilters }"
          @click.native="openFilters">
          <span
            class="button-item"
            slot="button-item">
            <img
              svg-inline
              src="~/assets/svg/redesign/filter.svg">
            <span class="counter _no-color">10</span>
          </span>
        </AppButton> -->
        <div class="appHeader-items">
          <!-- Выбор валюты -->
          <!-- Нет такого функционала -->
          <!--
          <AppSelectCurrency
            :options="currency"
            theme="darker"/>
          -->
          <AppButton
            :classes="['buttonLocation', '_none-round', '_transparent',]"
            @click.native="showLocationModal(); $ga('Contry','Click13'); $ym('search_city')">
            <span
              slot="button-item"
              class="button-item">
              <template v-if="!locationAutoDetected">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/location.svg">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/location-mobile.svg">
                <span class="button-label">{{ locationSelected ? location.name : 'Все страны' }}</span>
              </template>
              <template v-else>
                <AppPopover
                  v-if="locationSelected"
                  :options="tooltipLocationpOptions"
                  @apply-hide="disableAutoDetectLocation">
                  <span
                    slot="tooltip-trigger"
                    class="text">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/location.svg">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/location-mobile.svg">
                    <span class="button-label">{{ location.name }}</span>
                  </span>
                  <template slot="tooltip-content">
                    <no-ssr>
                      <span class="tooltip-text">Ваш город {{ location.name }}?</span>
                      <button
                        class="button"
                        v-close-popover>Да
                      </button>
                      <button
                        class="button buttonOutline"
                        @click="showLocationModal()"
                        v-close-popover>Изменить
                      </button>
                    </no-ssr>
                  </template>
                </AppPopover>
                <AppPopover
                  v-else
                  :options="tooltipLocationpOptions"
                  @apply-hide="onHideCityNotFoundTooltip">
                  <span
                    slot="tooltip-trigger"
                    class="text">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/location.svg">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/location-mobile.svg">
                    <span class="button-label">Все страны</span>
                  </span>
                  <template slot="tooltip-content">
                    <no-ssr>
                      <div class="paragraph">Мы не смогли определить ваш город автоматически.</div>
                      <button
                        class="button buttonOutline"
                        @click="showLocationModal()"
                        v-close-popover>Выберите город
                      </button>
                    </no-ssr>
                  </template>
                </AppPopover>
              </template>
            </span>
          </AppButton>

          <AppUserActions
            @login="login(); $ga('Enter','Click17'); $ym('enter')"
            :is-fixed-header="true"
            @logout="logout"
            :auth="auth">
            <template #entry-item>
              <AppButton
                @click.native="login(); $ga('Enter','Click17'); $ym('enter')"
                :classes="['_none-round', '_transparent', 'buttonLogin']">
                <img
                  slot="button-item"
                  svg-inline
                  src="~/assets/svg/redesign/login.svg">
              </AppButton>
            </template>
          </AppUserActions>

          <!--TODO: Нет страницы Козина-->
          <!--          <AppCart :cart="cart"/>-->
        </div>
      </div>
      <div
        class="menu container"
        :class="{'-open': hasOpenMenu}">
        <nav
          class="appHeader-navigation _tabs"
          v-show="hasOpenMenu">
          <flink
            href="/"
            domain="main"
            class="appHeader-navigation-item"
            :class="{'-active': navigation === 'parts'}"
            @click.native="$ga('Zap','Click18')">
            <img
              svg-inline
              src="~/assets/svg/redesign/navigation-parts.svg">
            Запчасти
          </flink>
          <flink
            href="/"
            domain="sto"
            class="appHeader-navigation-item"
            :class="{'-active': domain === $config.domains.sto }"
            @click.native="$ga('STO','Click19')">
            <img
              svg-inline
              src="~/assets/svg/redesign/navigation-sto.svg">
            Автотехцентры
          </flink>
          <flink
            href="/"
            domain="helper"
            class="appHeader-navigation-item"
            :class="{'-active': domain === $config.domains.helper }">
            <img
              svg-inline
              src="~/assets/svg/redesign/navigation-concierge.svg">
            Автоконсьерж
          </flink>
        </nav>
        <ul
          v-if="sections"
          class="menu-grid"
          :class="{'_column': hasOpenMenu}">
          <template v-for="(section, index) in sections">
            <li
              v-if="!(isSparePartsCatalogs(section) && isMobile()) && !(isPartsCategories(section) && !isMobile())"
              class="menu-grid-item"
              v-click-outside="onClickOutsideHeaderSubmenu"
              :key="index"
              :class="{'_catalogs': isSparePartsCatalogs(section)}">
              <!-- @todo проверить работу функционала-->
              <!-- до этого в некоторых пунктах меню active-class проставлялся через  -->
              <!-- :class="{ active: $route.path.startsWith('/wheels') }" -->
              <!-- или -->
              <!-- :class="{ active: $route.path.startsWith('/faq/') }" -->
              <flink
                :href="section.href"
                v-if="!isSparePartsCatalogs(section)"
                :active-class="isActiveClassSection(section)"
                exact-active-class="-active"
                :class="{'-active': isActive(section)}"
                :domain="section.domain"
                @click.native.prevent="disableFixBody">
                <span class="menu-section">
                  {{ section.title }}
                </span>
              </flink>
              <span
                @click="toggleHeaderSubMenuShow(section)"
                class="menu-section"
                :class="{'-active': isActive(section)}"
                v-else>
                {{ section.title }}
                <img
                  svg-inline
                  src="~/assets/svg/redesign/button-arrow-down-small.svg">
              </span>
              <PartsCatalogs
                :class="{ '-opened': isHeaderSubmenuOpened }"
                v-if="isSparePartsCatalogs(section)"/>
            </li>
          </template>
        </ul>
        <!--  TODO: Скрыли пока нет страницы корзины-->
        <!--        <AppCart :cart="cart"/>-->
        <footer
          class="menu-footer"
          v-show="hasOpenMenu">
          <!-- кнопка загрузки прайса -->
          <!--<AddPriceButton
            :auth="auth"
            @showAuthModal="showAuthModal"/>-->
          <div class="menu-footer-options">
            <!--         Выбор валюты     -->
            <!-- Нет такого функционала -->
            <!--
            <AppButton
              :classes="['_none-round', '_transparent', 'buttonLogin', '__fluid']"
              @click.native="login(); $ga('Enter','Click17'); $ym('enter')">
              <span
                slot="button-item"
                class="button-item">
                RUB
              </span>
            </AppButton>
            -->

            <!--
            <AppButton
              :classes="['_none-round', '_transparent', 'buttonLogin', '__fluid']"
              @click.native="login(); $ga('Enter','Click17'); $ym('enter')">
              <span
                slot="button-item"
                class="button-item">
                {{ (auth && auth.username) || 'Войти' }}
              </span>
            </AppButton>
            -->

            <AppUserActions
              :auth="auth"
              :is-fixed-header="true"
              :container="'.menu-footer-options .userActionsTrigger'"
              @login="login(); $ga('Enter','Click17'); $ym('enter')"
              @logout="logout"/>
          </div>
        </footer>
      </div>
    </div>
  </header>
</template>

<script>
import Header from '~/assets/js/mixins/redesign/header';

export default {
  name: 'HeaderFixed',
  mixins: [Header],
  computed: {
    burgerMenu() {
      return ['burgerMenu', '_transparent', '_none-round'];
    },
    buttonFilter() {
      return ['buttonFilter', '_none-round', '_transparent'];
    },
    buttonSearch() {
      return ['buttonSearch', '_none-round', '_transparent'];
    },
  },
};
</script>

<style lang="postcss">
  .appHeader._fixed {
    position: fixed;
    left: 0;
    top: 0;
    z-index: var(--z-index-under-modal);
    width: 100%;
    height: 4.375rem;
    background-color: var(--bg-main);
    box-shadow: 0 1px 3px rgba(0, 0, 0, 0.25);

    .logo {
      margin-left: 0.625rem;
      margin-right: 1.875rem;

      &-img {
        padding-right: 0.75rem;

        & > .svg {
          width: 6.875rem;
          height: 1.25rem;
        }
      }
    }

    .appHeader-wrapper {
      display: flex;
      align-items: stretch;
      height: inherit;
      flex-wrap: wrap;
    }

    .appHeader-top {
      display: flex;
      align-items: center;
      width: 100%;
      height: 100%;
      // flex-grow: 1;

      > .link {
        height: 100%;
      }

      > .button._transparent {
        margin-bottom: -1px;
        padding: 0;
        width: 2.75rem;
        height: calc(100% + 1px);
        flex-shrink: 0;

        &:hover, &:active, &:focus, &.-open {
          .svg {
            fill: var(--fill-active);
          }
        }

        & .svg {
          width: 1.25rem;
          height: auto;
          fill: var(--fill-light);
          transition: fill .1s var(--transition-easeOutQuad);

          &.menu-close {
            display: none;
          }
        }

        &.-open {
          position: relative;
          z-index: 1;
          background-color: var(--bg-lightest);
          border-left: 1px solid var(--border-color-lighten);
          border-right: 1px solid var(--border-color-lighten);
        }
      }

      .buttonSearch {
        display: none;
      }

      .buttonFilter {
        margin-left: 0.625rem;
        .button-item {
          position: relative;
        }
        .counter {
          position: absolute;
          bottom: -0.375rem;
        }
      }
    }

    .appHeader-items {
      display: flex;
      justify-content: flex-end;
      align-items: stretch;
      margin-left: auto;
      height: 100%;

      .button._transparent {
        justify-content: flex-start;
        margin: 0 0.75rem;
        padding: 0;
        height: 100%;
        width: auto;
        font-size: 0.75rem;
        font-weight: var(--font-weight-regular);
        color: var(--color-main-lightest);

        .button-item {
          transition: color .1s var(--transition-easeOutQuad);
        }

        .button-label {
          display: inline-flex;
          max-width: 11rem;
          white-space: nowrap;
          overflow: hidden;
          transition: none;
        }

        &:hover, &:active, &:focus {
          color: var(--color-main);

          .button-item .svg {
            fill: var(--fill-active);
          }
        }

        &.buttonLogin {
          justify-content: flex-end;
          padding: 0;
          width: 1.75rem;
        }

        &.buttonLocation {
          position: relative;
          .svg.svgLocation {
            position: absolute;
            top: 50%;
            left: -1rem;
            display: block;
            margin-top: -0.5rem;
            width: 0.875rem;
            height: auto;
            stroke: var(--color-main-lightest);
            fill: none;
            transition: stroke .1s var(--transition-easeOutQuad);
          }

          .svg.svgLocationMobile {
            display: none;
          }

          &:hover, &:active, &:focus {
            .svg.svgLocation {
              stroke: var(--color-main);
            }
          }
        }
      }

      .userActionsPopover {
        right: -0.875rem !important;
        box-shadow: none;
        background-color: var(--bg-lightest);

        .__hide-shadow:after {
          background-image: linear-gradient(270deg,var(--bg-lightest) 18%,var(--bg-transparent));
        }
      }

      > .appCart {
        margin-left: 0.75rem;
        margin-right: -1rem;

        .appCart-amount {
          display: none;
        }
      }
    }

    .appHeader-filters {
      position: absolute;
      top: 100%;
      left: 0;
      right: 0;
      border-radius: 0;
      border-top: 1px solid var(--border-color-main);

      .filterGroup {
        position: relative;
        margin: 0 auto;
        padding: 0.5rem 0;
        max-width: 79.625rem;

        &-header {
          display: flex;
        }

        .heading {
          display: none;
        }
      }
    }

    .menu {
      position: relative;
      display: flex;
      flex-grow: 1;
      width: 100%;
      height: 0;
      border-top: 1px solid transparent;
      border-bottom: 1px solid transparent;
      background-color: var(--bg-lightest);
      visibility: hidden;

      .menu-grid {
        display: flex;
        align-items: center;
        width: 100%;
      }

      .menu-section {
        position: relative;
        display: flex;
        align-items: center;
        margin-bottom: -1px;
        padding: 0.5625rem 1.25rem 0.625rem 1.25rem;
        font-size: 0.875rem;
        color: var(--color-main);
        transition: color .1s var(--transition-easeOutQuad);

        &::after {
          content: '';
          position: absolute;
          bottom: 0;
          left: 0;
          height: 0.125rem;
          width: 100%;
          background-color: transparent;
          visibility: hidden;
          transition: background-color .1s var(--transition-easeOutQuad), visibility .1s var(--transition-easeOutQuad);
        }

        &:active {
          color: var(--link-dark-active-color);
        }

        &:hover, &:focus {
          color: var(--link-dark-hover-color);

          & > .svg {
            fill: var(--link-dark-hover-color);
          }
        }

        & > .svg {
          margin-left: 0.375rem;
          fill: var(--color-main);
          transition: fill .1s var(--transition-easeOutQuad);
        }
      }

      .appHeader-navigation._tabs,
      .menu-footer,
      .partsCatalogs,
      .appCart {
        display: none;
      }

      .menu-grid-item._catalogs {
        cursor: pointer;

        & .partsCatalogs.-opened {
          display: block;
        }

        .menu-section {
          font-size: 0.875rem;
s
          .active {
            font-weight: var(--font-weight-medium);
            &::after {
              background-color: var(--header-nav-active-border);
              visibility: visible;
            }
          }
        }
      }

      &.-open {
        height: 2.375rem;
        visibility: visible;
        border-top-color: var(--border-color-light);
        border-bottom-color: var(--border-color-light);

        .menu-grid .-active {
          .menu-section {
            font-weight: var(--font-weight-medium);
            &::after {
              background-color: var(--header-nav-active-border);
              visibility: visible;
            }
          }
        }

        .menu-grid {
          .menu-section {
            &.-active {
              font-weight: var(--font-weight-medium);
              font-size: 0.875rem;

              &::after {
                background-color: var(--header-nav-active-border);
                visibility: visible;

                @media only screen and ( max-width: 980px ) {
                  visibility: hidden;
                }
              }
            }
          }
        }
      }
    }


    .buttonFilter {

      .button-item {
        display: inline-block;
        min-height: 1.25rem;
      }

      .svg {
        fill: var(--color-main-lightest);
      }
    }

    .appSearch {
      max-width: 32.125rem;
      min-width: 22.125rem;

      & .input-field,
      & .button {
        height: 2rem;
        min-height: 2rem;
      }

      @media only screen and ( min-width: 1260px ) {
        max-width: 45rem;
      }
    }

    @media screen and (max-width: 1200px) and (min-width: 981px) {
      .logo-img {
        padding: 0;
        padding-bottom: .5rem;
      }

      .menu-grid {
        padding-left: 2.25rem;
        padding-right: 1.25rem;
      }

      .menu-section {
        padding: 2.125rem 0.875rem;
      }

      .appSearch {
        height: var(--btn-height-regular);
      }

      .appHeader-filters {
        .filterGroup {
          padding-left: 2.875rem;
          padding-right: 2.875rem;
          &-close {
            right: 2.875rem;
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      height: auto;
      max-height: 100vh;

      &.-open-menu {
        height: 100vh;
        overflow-y: auto;
        .appHeader-wrapper {
          flex-direction: column;
          flex-wrap: nowrap;
        }
        .appHeader-top {
          flex-shrink: 0;

          > .link {
            display: none;
          }

          .buttonFilter,
          .buttonSearch,
          .appSearch {
            display: none;
          }

          .appHeader-items {
            margin-left: auto;
          }

          .button.buttonLocation {
            display: flex;
            max-width: calc(100vw - 7rem);
            font-size: 1.125rem;
            text-align: left;
            color: var(--color-main-lightest);
            .svg.svgLocationMobile {
              display: inline-block;
              vertical-align: bottom;
              flex-shrink: 0;
              margin-right: 0.625rem;
              width: 1.25rem;
              height: auto;
              fill: var(--fill-light);
            }
            .svg.svgLocation {
              display: none;
            }
            .button-item {
              display: inline-flex;
              align-items: center;
            }
            .button-label {
              white-space: normal;
            }
          }
        }
      }

      .appHeader-items {
        margin: 0;
        .multiselect,
        .appCart,
        .buttonSearch,
        .buttonFilter,
        .buttonLocation,
        .buttonLogin {
          display: none;
        }
      }

      .appHeader-filters {
        position: static;

        .filterGroup {
          position: fixed;
          padding: 0 1.25rem;
          background-color: var(--bg-lightest);
          .heading {
            display: block;
          }
        }
      }

      .appSearch {
        position: absolute;
        left: 0;
        right: 0;
        top: calc(100% - 1px);
        max-width: 100%;
        visibility: hidden;
        opacity: 0;
        transition: visibility .1s var(--transition-easeOutQuad), opacity .3s var(--transition-easeOutQuad);

        .input {
          background-color: var(--bg-lightest);

          &-field {
            border-radius: 0;
            border-left: none;
            border-right: none;
          }

          .button {
            min-width: 3.5rem;
            background-size: auto;
            background-position: center;
            background-repeat: no-repeat;
            background-image: url("~assets/svg/redesign/search-arrow.svg");

            .svg {
              display: none;
            }
          }
        }

        &.-open {
          opacity: 1;
          visibility: visible;
        }
      }

      .appHeader-top {
        height: 4.375rem;
        padding: 0 0.375rem;
        .user-actions-popover-wrapper {
          display: none;
        }

        .button._transparent {
          margin: 0;
          padding: 0 0.875rem;
          width: auto;

          .svg {
            width: auto;
            height: 1.625rem;
            fill: var(--color-main-lightest);
          }

          &:hover, &:active, &:focus, &.-active {
            .svg {
              fill: var(--color-main-lightest);
            }
          }
        }

        .button.burgerMenu.-open {
          background-color: transparent;
          border: none;
          .svg.menu-open {
            display: none;
          }
          .svg.menu-close {
            display: block;
            fill: var(--color-main-lightest);
          }
        }

        .buttonSearch {
          display: inline-flex;
        }

        .buttonFilter {
          margin-left: 0;
          .counter {
            display: none;
          }
        }

        > .link {
          margin-right: auto;
        }
      }

      .logo {
        margin: 0;

        &-img {
          padding-right: 0;

          > .svg {
            width: 8.125rem;
            height: 1.375rem;
          }
        }

      }

      .menu {
        flex-direction: column;
        padding: 0;
        background-color: var(--bg-main);
        border: none;

        & .menu-grid {
          flex-direction: column;
          align-items: flex-start;
          padding-left: 0;
          border: none;

          &-item {
            width: 100%;

            &._catalogs .menu-section {
              display: none;
            }
          }
        }

        & .menu-section {
          margin-bottom: 0;
          padding-top: 1.375rem;
          padding-bottom: 1.375rem;
          width: 100%;
          font-size: 0.875rem;
          font-weight: var(--font-weight-medium);
          border-bottom: 1px solid var(--border-color-main);

          &::after {
            content: none;
          }
        }

        & .menu-footer {
          display: flex;
          align-items: center;
          justify-content: center;
          flex-direction: column;
          flex-shrink: 0;
          width: 100%;
          min-height: 4rem;
          margin-top: auto;
          padding: 0.5rem 1.125rem calc(0.5rem + var(--mobile-browser-bar));
          background-color: var(--bg-darktset);

          .buttonAddItem {
            margin-bottom: 1.25rem;
            height: var(--btn-mobile-min-height);
            width: calc(100vw - 2.5rem);
            font-size: 1.125rem;
            border-radius: 0.25rem;
          }

          .menu-footer-options {
            display: flex;
            align-items: center;
            justify-content: center;
            width: 100%;

            .buttonLogin {
              padding: 0;
              min-height: 3rem;
              font-size: 1.125rem;
              color: var(--bg-main);
            }
          }
        }

        &.-open {
          height: calc(100% - 4.375rem);
          @supports (-webkit-overflow-scrolling: touch) { /* IOS DEVICES */
            display: block;
          }
        }

        .partsCatalogs {
          position: static;
          display: block;
        }

        .appHeader-navigation._tabs {
          display: flex;
          padding: 0;
          width: 100%;
          border-top: 1px solid var(--border-color-main);
          border-bottom: 1px solid var(--border-color-main);
          background-color: transparent;

          & .appHeader-navigation-item {
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            padding: 0 1.25rem;
            width: 33.333%;
            height: 5.5rem;
            font-size: 0.75rem;
            color: var(--color-main);

            &.-active {
              background-color: var(--btn-bg);
            }

            .svg {
              flex-shrink: 0;
              display: block;
              margin-bottom: 0.5rem;
              width: 2.375rem;
              height: auto;
              fill: var(--color-main);
            }
          }
        }

        .appCart {
          display: block;
          padding: 2rem 1.125rem 2.75rem 1.125rem;
          width: 100%;
          background-color: var(--bg-main);
        }
      }
    }
    @media only screen and ( max-width: 340px ) {
      .appHeader-top .button._transparent {
        padding: 0 .875rem 0 .475rem;
      }
    }
  }
</style>
